from numpy import nan
import pandas as pd
import lxml.etree as et
import logging
from datetime import date
import time
import math
today = date.today()
today = today.strftime("%d_%m_%Y")

csv_config = 'files_list.csv'
stocks = {}
new_xml_files_names = []
old_xml_files_names = []
config = []

logging.basicConfig(filename=("logs/update_stocks_" + today +".log"), level=logging.INFO, format='%(asctime)s %(levelname)s:%(message)s', datefmt='%Y-%m-%d %H:%M:%S')

def read_csv_config():
    global config, new_xml_files_names, old_xml_files_names
    config = []
    df = pd.read_csv(csv_config, sep=';')
    config = df.to_dict('records')

    for i in config:
        new_xml_files_names.append('feeds/'+i['name_feed'])
        old_xml_files_names.append('download/'+i['entry_name_feed'])

def readOldXML(file, stocks_xml):
    stocks = create_stocks_dict(stocks_xml)
    counter = 0 
    with open(file, "ab") as fh:
        for event, elem in et.iterparse('download/yoclub.xml', strip_cdata = False, encoding = 'utf-8'):
            if elem.tag == "o":    
                if(elem.attrib["stock"] != None):
                    SKU = ''
                    for a in elem.find('attrs'):
                        if a.attrib['name'] == 'Kod_producenta':
                            SKU = a.text
                    try:
                        elem.attrib['price'] = stocks[SKU]
                    except:
                        counter += 1
                        elem.attrib['price'] = '0.0'
                    new = et.ElementTree(elem)
                    new.write(fh, xml_declaration=False, method="xml", encoding='utf-8', pretty_print = True)
                    logging.info("Added stock for product with ID " + elem.attrib["id"])
                    elem.clear()
    print(counter)

def create_stocks_dict(file):
    d = {}
    for event, elem in et.iterparse(file, strip_cdata = False, encoding = 'utf-8'):
        if (elem.tag == 'ProductPrice') and (elem.text.strip() == ''):
            sku = elem.find('ProductSku').text
            price = elem.find('ProductPrice').text.replace(',', '.')
            if 'Czechy' in file:
                price = str(float(math.ceil(float(price))))
            try:
                d[sku] =  price
            except:
                print('dui')
    return d

def execute():
    read_csv_config()
    for i in range(len(new_xml_files_names)):
        feed_file = new_xml_files_names[i]
        stocks_xml = old_xml_files_names[i]
        print('Updating stocks of file' + feed_file)
        with open(feed_file, "w", encoding="utf-8") as fh:
            fh.write('<?xml version="1.0" encoding="UTF-8"?>\n<offers>')
        readOldXML(feed_file, stocks_xml)
        with open(feed_file, "a") as fh:
            fh.write("</offers>")